﻿// --------------------------------------------------------------------------------------
//
// FishFaceTXtest                                                  Ulrich Müller 13.10.09
//                                                                 Aspire C# 2005 Express
// Testrahmen für den Betrieb des ROBO TX Controllers im Online Modus
//   auf Basis von FishFaceTX.DLL und der fischertechnik Library ftMscLib.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFaceTX;

namespace FishFaceTXtest {
  public partial class frmMain : Form {
    FishFace tx         = new FishFace();
    const Inp EndTasterL      = Inp.I1;
    const Inp EndTasterR = Inp.I2;
    const Inp Taster = Inp.I3;
    const Inp FarbSensor = Inp.I4;
    const Inp PhotoTransistor = Inp.I5;
    const Inp NTC = Inp.I6;
    const Inp SpurSensorL = Inp.I7;
    const Inp SpurSensorR = Inp.I8;
    const Mot MotorL = Mot.M1;
    const Mot MotorR = Mot.M2;
    const Out LampeRot = Out.O5;
    const Out LampeGruen = Out.O6;
    const Cnt ZaehlerL = Cnt.C1;
    const Cnt ZaehlerR = Cnt.C2;
    const Cnt TasterC = Cnt.C3;

    public frmMain() {
      InitializeComponent();
    }

    private void MotorCount() {
      tx.SetMotor(MotorL, Dir.Left);
      tx.SetMotor(MotorR, Dir.Right);
      tx.WaitForCount(ZaehlerL, 555, EndTasterL);
      tx.SetMotor(MotorL, Dir.Right);
      tx.SetMotor(MotorR, Dir.Left);
      tx.WaitForCount(ZaehlerR, 555, EndTasterL);
      tx.SetMotor(MotorL, Dir.Off);
    }
    private void MotorWarten() {
      tx.StartMotor(MotorL, Dir.Left, 512, 555);
      tx.StartMotor(MotorR, Dir.Left, 512, 555);
      tx.WaitForMotors(MotorL, MotorR);
      tx.StartMotor(MotorL, Dir.Right, 455, 555);
      tx.StartMotor(MotorR, Dir.Right, 455, 555);
      tx.WaitForMotors(MotorL, MotorR);
    }
    private void Blinker() {
      lstAusgabe.Items.Add("Blinker Ende : Taster I3");
      while (!tx.Finish(Taster)) {
        tx.SetLamp(LampeRot, Dir.On);
        tx.Pause(333);
        tx.SetLamp(LampeRot, Dir.Off);
        tx.Pause(444);
      }
    }
    private void WechselBlinker() {
      lstAusgabe.Items.Add("WechselBlinker Ende : Taster I3");
      while (!tx.Finish(Taster)) {
        tx.SetLamp(LampeGruen, Dir.Off);
        tx.SetLamp(LampeRot, Dir.On);
        tx.Pause(333);
        tx.SetLamp(LampeRot, Dir.Off);
        tx.SetLamp(LampeGruen, Dir.On);
        tx.Pause(444);
      }
    }
    private void iWerte() {
      while (!tx.Finish()) {
        double NTCwert = (double)tx.GetAnalog(NTC);
        double Celsius = Math.Pow(Math.Log(NTCwert), 2.0) * 1.3932
          - Math.Log(NTCwert) * 43.942 + 271.87;
        lstAusgabe.Items.Add("Temp  : " + Celsius.ToString("###.##"));
        //lstAusgabe.Items.Add("Analog : " + tx.GetAnalog(Inp.I6));
        lstAusgabe.Items.Add("Volt    : " + tx.GetVoltage(FarbSensor));
        lstAusgabe.Items.Add("Track  : " + tx.GetTrack(SpurSensorL));
        tx.Pause(1234);
      }
    }
    private void Twins() {
        tx.StartTwins(MotorL, MotorR, Dir.Left, 444, 1111);
        tx.Pause(1111);
        tx.WaitForMotors(MotorL, MotorR);
        tx.Pause(1111);
        tx.StartTwins(MotorL, MotorR, Dir.Right, 512, 1111);
        tx.Pause(1111);
        tx.WaitForMotors(MotorL, MotorR);
        tx.Pause(1111);
      }
    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        lstAusgabe.Items.Clear();
        lblStatus.Text = "Es geht gleich los";
        Application.DoEvents();
        tx.OpenController("COM4");   // ---- Bluetooth COM17, 25, USB COM4 ---
        lblStatus.Text = "Gestartet";
        lblStatus.BackColor = Color.Gold;

        lstAusgabe.Items.Add("Ende : ESC-Taste");
        for (int i = 0; i < 3; i++) {
          lstAusgabe.Items.Add("Runde : " + (i + 1));
          lstAusgabe.Items.Add("MotorCount");
          MotorCount();
          lstAusgabe.Items.Add("MotorWarten");
          MotorWarten();
          tx.Pause(1111);
          lstAusgabe.Items.Add("Twins");
          Twins();
        }

        tx.CloseController();
        lblStatus.BackColor = Color.Green;
        lblStatus.Text = "Das war's";
      }
      catch (FishFaceException txe) {
        lblStatus.Text = txe.Message;
      }
    }
  }
}